package com.hfkj.dao;

import com.hfkj.entity.BsOrderAfterSalesApply;
import com.hfkj.entity.BsOrderAfterSalesApplyExample.Criteria;
import com.hfkj.entity.BsOrderAfterSalesApplyExample.Criterion;
import com.hfkj.entity.BsOrderAfterSalesApplyExample;
import java.util.List;
import java.util.Map;
import org.apache.ibatis.jdbc.SQL;

public class BsOrderAfterSalesApplySqlProvider {

    public String countByExample(BsOrderAfterSalesApplyExample example) {
        SQL sql = new SQL();
        sql.SELECT("count(*)").FROM("bs_order_after_sales_apply");
        applyWhere(sql, example, false);
        return sql.toString();
    }

    public String deleteByExample(BsOrderAfterSalesApplyExample example) {
        SQL sql = new SQL();
        sql.DELETE_FROM("bs_order_after_sales_apply");
        applyWhere(sql, example, false);
        return sql.toString();
    }

    public String insertSelective(BsOrderAfterSalesApply record) {
        SQL sql = new SQL();
        sql.INSERT_INTO("bs_order_after_sales_apply");
        
        if (record.getUserId() != null) {
            sql.VALUES("user_id", "#{userId,jdbcType=BIGINT}");
        }
        
        if (record.getUserPhone() != null) {
            sql.VALUES("user_phone", "#{userPhone,jdbcType=VARCHAR}");
        }
        
        if (record.getMerId() != null) {
            sql.VALUES("mer_id", "#{merId,jdbcType=BIGINT}");
        }
        
        if (record.getApplyNo() != null) {
            sql.VALUES("apply_no", "#{applyNo,jdbcType=VARCHAR}");
        }
        
        if (record.getType() != null) {
            sql.VALUES("`type`", "#{type,jdbcType=INTEGER}");
        }
        
        if (record.getOrderNo() != null) {
            sql.VALUES("order_no", "#{orderNo,jdbcType=VARCHAR}");
        }
        
        if (record.getChildOrderNo() != null) {
            sql.VALUES("child_order_no", "#{childOrderNo,jdbcType=VARCHAR}");
        }
        
        if (record.getProductType() != null) {
            sql.VALUES("product_type", "#{productType,jdbcType=INTEGER}");
        }
        
        if (record.getProductId() != null) {
            sql.VALUES("product_id", "#{productId,jdbcType=BIGINT}");
        }
        
        if (record.getProductName() != null) {
            sql.VALUES("product_name", "#{productName,jdbcType=VARCHAR}");
        }
        
        if (record.getProductImg() != null) {
            sql.VALUES("product_img", "#{productImg,jdbcType=VARCHAR}");
        }
        
        if (record.getProductSpecId() != null) {
            sql.VALUES("product_spec_id", "#{productSpecId,jdbcType=BIGINT}");
        }
        
        if (record.getProductSpecName() != null) {
            sql.VALUES("product_spec_name", "#{productSpecName,jdbcType=VARCHAR}");
        }
        
        if (record.getProductCount() != null) {
            sql.VALUES("product_count", "#{productCount,jdbcType=INTEGER}");
        }
        
        if (record.getPhoto() != null) {
            sql.VALUES("photo", "#{photo,jdbcType=VARCHAR}");
        }
        
        if (record.getRemarks() != null) {
            sql.VALUES("remarks", "#{remarks,jdbcType=VARCHAR}");
        }
        
        if (record.getSendExpressNo() != null) {
            sql.VALUES("send_express_no", "#{sendExpressNo,jdbcType=VARCHAR}");
        }
        
        if (record.getRefundOrderNo() != null) {
            sql.VALUES("refund_order_no", "#{refundOrderNo,jdbcType=VARCHAR}");
        }
        
        if (record.getRefundPrice() != null) {
            sql.VALUES("refund_price", "#{refundPrice,jdbcType=DECIMAL}");
        }
        
        if (record.getRefundIntegral() != null) {
            sql.VALUES("refund_integral", "#{refundIntegral,jdbcType=BIGINT}");
        }
        
        if (record.getStatus() != null) {
            sql.VALUES("`status`", "#{status,jdbcType=INTEGER}");
        }
        
        if (record.getAuditRemarks() != null) {
            sql.VALUES("audit_remarks", "#{auditRemarks,jdbcType=VARCHAR}");
        }
        
        if (record.getCreateTime() != null) {
            sql.VALUES("create_time", "#{createTime,jdbcType=TIMESTAMP}");
        }
        
        if (record.getAuditTime() != null) {
            sql.VALUES("audit_time", "#{auditTime,jdbcType=TIMESTAMP}");
        }
        
        if (record.getSendExpressTime() != null) {
            sql.VALUES("send_express_time", "#{sendExpressTime,jdbcType=TIMESTAMP}");
        }
        
        if (record.getFinishTime() != null) {
            sql.VALUES("finish_time", "#{finishTime,jdbcType=TIMESTAMP}");
        }
        
        if (record.getUpdateTime() != null) {
            sql.VALUES("update_time", "#{updateTime,jdbcType=TIMESTAMP}");
        }
        
        if (record.getExt1() != null) {
            sql.VALUES("ext_1", "#{ext1,jdbcType=VARCHAR}");
        }
        
        if (record.getExt2() != null) {
            sql.VALUES("ext_2", "#{ext2,jdbcType=VARCHAR}");
        }
        
        if (record.getExt3() != null) {
            sql.VALUES("ext_3", "#{ext3,jdbcType=VARCHAR}");
        }
        
        return sql.toString();
    }

    public String selectByExample(BsOrderAfterSalesApplyExample example) {
        SQL sql = new SQL();
        if (example != null && example.isDistinct()) {
            sql.SELECT_DISTINCT("id");
        } else {
            sql.SELECT("id");
        }
        sql.SELECT("user_id");
        sql.SELECT("user_phone");
        sql.SELECT("mer_id");
        sql.SELECT("apply_no");
        sql.SELECT("`type`");
        sql.SELECT("order_no");
        sql.SELECT("child_order_no");
        sql.SELECT("product_type");
        sql.SELECT("product_id");
        sql.SELECT("product_name");
        sql.SELECT("product_img");
        sql.SELECT("product_spec_id");
        sql.SELECT("product_spec_name");
        sql.SELECT("product_count");
        sql.SELECT("photo");
        sql.SELECT("remarks");
        sql.SELECT("send_express_no");
        sql.SELECT("refund_order_no");
        sql.SELECT("refund_price");
        sql.SELECT("refund_integral");
        sql.SELECT("`status`");
        sql.SELECT("audit_remarks");
        sql.SELECT("create_time");
        sql.SELECT("audit_time");
        sql.SELECT("send_express_time");
        sql.SELECT("finish_time");
        sql.SELECT("update_time");
        sql.SELECT("ext_1");
        sql.SELECT("ext_2");
        sql.SELECT("ext_3");
        sql.FROM("bs_order_after_sales_apply");
        applyWhere(sql, example, false);
        
        if (example != null && example.getOrderByClause() != null) {
            sql.ORDER_BY(example.getOrderByClause());
        }
        
        return sql.toString();
    }

    public String updateByExampleSelective(Map<String, Object> parameter) {
        BsOrderAfterSalesApply record = (BsOrderAfterSalesApply) parameter.get("record");
        BsOrderAfterSalesApplyExample example = (BsOrderAfterSalesApplyExample) parameter.get("example");
        
        SQL sql = new SQL();
        sql.UPDATE("bs_order_after_sales_apply");
        
        if (record.getId() != null) {
            sql.SET("id = #{record.id,jdbcType=BIGINT}");
        }
        
        if (record.getUserId() != null) {
            sql.SET("user_id = #{record.userId,jdbcType=BIGINT}");
        }
        
        if (record.getUserPhone() != null) {
            sql.SET("user_phone = #{record.userPhone,jdbcType=VARCHAR}");
        }
        
        if (record.getMerId() != null) {
            sql.SET("mer_id = #{record.merId,jdbcType=BIGINT}");
        }
        
        if (record.getApplyNo() != null) {
            sql.SET("apply_no = #{record.applyNo,jdbcType=VARCHAR}");
        }
        
        if (record.getType() != null) {
            sql.SET("`type` = #{record.type,jdbcType=INTEGER}");
        }
        
        if (record.getOrderNo() != null) {
            sql.SET("order_no = #{record.orderNo,jdbcType=VARCHAR}");
        }
        
        if (record.getChildOrderNo() != null) {
            sql.SET("child_order_no = #{record.childOrderNo,jdbcType=VARCHAR}");
        }
        
        if (record.getProductType() != null) {
            sql.SET("product_type = #{record.productType,jdbcType=INTEGER}");
        }
        
        if (record.getProductId() != null) {
            sql.SET("product_id = #{record.productId,jdbcType=BIGINT}");
        }
        
        if (record.getProductName() != null) {
            sql.SET("product_name = #{record.productName,jdbcType=VARCHAR}");
        }
        
        if (record.getProductImg() != null) {
            sql.SET("product_img = #{record.productImg,jdbcType=VARCHAR}");
        }
        
        if (record.getProductSpecId() != null) {
            sql.SET("product_spec_id = #{record.productSpecId,jdbcType=BIGINT}");
        }
        
        if (record.getProductSpecName() != null) {
            sql.SET("product_spec_name = #{record.productSpecName,jdbcType=VARCHAR}");
        }
        
        if (record.getProductCount() != null) {
            sql.SET("product_count = #{record.productCount,jdbcType=INTEGER}");
        }
        
        if (record.getPhoto() != null) {
            sql.SET("photo = #{record.photo,jdbcType=VARCHAR}");
        }
        
        if (record.getRemarks() != null) {
            sql.SET("remarks = #{record.remarks,jdbcType=VARCHAR}");
        }
        
        if (record.getSendExpressNo() != null) {
            sql.SET("send_express_no = #{record.sendExpressNo,jdbcType=VARCHAR}");
        }
        
        if (record.getRefundOrderNo() != null) {
            sql.SET("refund_order_no = #{record.refundOrderNo,jdbcType=VARCHAR}");
        }
        
        if (record.getRefundPrice() != null) {
            sql.SET("refund_price = #{record.refundPrice,jdbcType=DECIMAL}");
        }
        
        if (record.getRefundIntegral() != null) {
            sql.SET("refund_integral = #{record.refundIntegral,jdbcType=BIGINT}");
        }
        
        if (record.getStatus() != null) {
            sql.SET("`status` = #{record.status,jdbcType=INTEGER}");
        }
        
        if (record.getAuditRemarks() != null) {
            sql.SET("audit_remarks = #{record.auditRemarks,jdbcType=VARCHAR}");
        }
        
        if (record.getCreateTime() != null) {
            sql.SET("create_time = #{record.createTime,jdbcType=TIMESTAMP}");
        }
        
        if (record.getAuditTime() != null) {
            sql.SET("audit_time = #{record.auditTime,jdbcType=TIMESTAMP}");
        }
        
        if (record.getSendExpressTime() != null) {
            sql.SET("send_express_time = #{record.sendExpressTime,jdbcType=TIMESTAMP}");
        }
        
        if (record.getFinishTime() != null) {
            sql.SET("finish_time = #{record.finishTime,jdbcType=TIMESTAMP}");
        }
        
        if (record.getUpdateTime() != null) {
            sql.SET("update_time = #{record.updateTime,jdbcType=TIMESTAMP}");
        }
        
        if (record.getExt1() != null) {
            sql.SET("ext_1 = #{record.ext1,jdbcType=VARCHAR}");
        }
        
        if (record.getExt2() != null) {
            sql.SET("ext_2 = #{record.ext2,jdbcType=VARCHAR}");
        }
        
        if (record.getExt3() != null) {
            sql.SET("ext_3 = #{record.ext3,jdbcType=VARCHAR}");
        }
        
        applyWhere(sql, example, true);
        return sql.toString();
    }

    public String updateByExample(Map<String, Object> parameter) {
        SQL sql = new SQL();
        sql.UPDATE("bs_order_after_sales_apply");
        
        sql.SET("id = #{record.id,jdbcType=BIGINT}");
        sql.SET("user_id = #{record.userId,jdbcType=BIGINT}");
        sql.SET("user_phone = #{record.userPhone,jdbcType=VARCHAR}");
        sql.SET("mer_id = #{record.merId,jdbcType=BIGINT}");
        sql.SET("apply_no = #{record.applyNo,jdbcType=VARCHAR}");
        sql.SET("`type` = #{record.type,jdbcType=INTEGER}");
        sql.SET("order_no = #{record.orderNo,jdbcType=VARCHAR}");
        sql.SET("child_order_no = #{record.childOrderNo,jdbcType=VARCHAR}");
        sql.SET("product_type = #{record.productType,jdbcType=INTEGER}");
        sql.SET("product_id = #{record.productId,jdbcType=BIGINT}");
        sql.SET("product_name = #{record.productName,jdbcType=VARCHAR}");
        sql.SET("product_img = #{record.productImg,jdbcType=VARCHAR}");
        sql.SET("product_spec_id = #{record.productSpecId,jdbcType=BIGINT}");
        sql.SET("product_spec_name = #{record.productSpecName,jdbcType=VARCHAR}");
        sql.SET("product_count = #{record.productCount,jdbcType=INTEGER}");
        sql.SET("photo = #{record.photo,jdbcType=VARCHAR}");
        sql.SET("remarks = #{record.remarks,jdbcType=VARCHAR}");
        sql.SET("send_express_no = #{record.sendExpressNo,jdbcType=VARCHAR}");
        sql.SET("refund_order_no = #{record.refundOrderNo,jdbcType=VARCHAR}");
        sql.SET("refund_price = #{record.refundPrice,jdbcType=DECIMAL}");
        sql.SET("refund_integral = #{record.refundIntegral,jdbcType=BIGINT}");
        sql.SET("`status` = #{record.status,jdbcType=INTEGER}");
        sql.SET("audit_remarks = #{record.auditRemarks,jdbcType=VARCHAR}");
        sql.SET("create_time = #{record.createTime,jdbcType=TIMESTAMP}");
        sql.SET("audit_time = #{record.auditTime,jdbcType=TIMESTAMP}");
        sql.SET("send_express_time = #{record.sendExpressTime,jdbcType=TIMESTAMP}");
        sql.SET("finish_time = #{record.finishTime,jdbcType=TIMESTAMP}");
        sql.SET("update_time = #{record.updateTime,jdbcType=TIMESTAMP}");
        sql.SET("ext_1 = #{record.ext1,jdbcType=VARCHAR}");
        sql.SET("ext_2 = #{record.ext2,jdbcType=VARCHAR}");
        sql.SET("ext_3 = #{record.ext3,jdbcType=VARCHAR}");
        
        BsOrderAfterSalesApplyExample example = (BsOrderAfterSalesApplyExample) parameter.get("example");
        applyWhere(sql, example, true);
        return sql.toString();
    }

    public String updateByPrimaryKeySelective(BsOrderAfterSalesApply record) {
        SQL sql = new SQL();
        sql.UPDATE("bs_order_after_sales_apply");
        
        if (record.getUserId() != null) {
            sql.SET("user_id = #{userId,jdbcType=BIGINT}");
        }
        
        if (record.getUserPhone() != null) {
            sql.SET("user_phone = #{userPhone,jdbcType=VARCHAR}");
        }
        
        if (record.getMerId() != null) {
            sql.SET("mer_id = #{merId,jdbcType=BIGINT}");
        }
        
        if (record.getApplyNo() != null) {
            sql.SET("apply_no = #{applyNo,jdbcType=VARCHAR}");
        }
        
        if (record.getType() != null) {
            sql.SET("`type` = #{type,jdbcType=INTEGER}");
        }
        
        if (record.getOrderNo() != null) {
            sql.SET("order_no = #{orderNo,jdbcType=VARCHAR}");
        }
        
        if (record.getChildOrderNo() != null) {
            sql.SET("child_order_no = #{childOrderNo,jdbcType=VARCHAR}");
        }
        
        if (record.getProductType() != null) {
            sql.SET("product_type = #{productType,jdbcType=INTEGER}");
        }
        
        if (record.getProductId() != null) {
            sql.SET("product_id = #{productId,jdbcType=BIGINT}");
        }
        
        if (record.getProductName() != null) {
            sql.SET("product_name = #{productName,jdbcType=VARCHAR}");
        }
        
        if (record.getProductImg() != null) {
            sql.SET("product_img = #{productImg,jdbcType=VARCHAR}");
        }
        
        if (record.getProductSpecId() != null) {
            sql.SET("product_spec_id = #{productSpecId,jdbcType=BIGINT}");
        }
        
        if (record.getProductSpecName() != null) {
            sql.SET("product_spec_name = #{productSpecName,jdbcType=VARCHAR}");
        }
        
        if (record.getProductCount() != null) {
            sql.SET("product_count = #{productCount,jdbcType=INTEGER}");
        }
        
        if (record.getPhoto() != null) {
            sql.SET("photo = #{photo,jdbcType=VARCHAR}");
        }
        
        if (record.getRemarks() != null) {
            sql.SET("remarks = #{remarks,jdbcType=VARCHAR}");
        }
        
        if (record.getSendExpressNo() != null) {
            sql.SET("send_express_no = #{sendExpressNo,jdbcType=VARCHAR}");
        }
        
        if (record.getRefundOrderNo() != null) {
            sql.SET("refund_order_no = #{refundOrderNo,jdbcType=VARCHAR}");
        }
        
        if (record.getRefundPrice() != null) {
            sql.SET("refund_price = #{refundPrice,jdbcType=DECIMAL}");
        }
        
        if (record.getRefundIntegral() != null) {
            sql.SET("refund_integral = #{refundIntegral,jdbcType=BIGINT}");
        }
        
        if (record.getStatus() != null) {
            sql.SET("`status` = #{status,jdbcType=INTEGER}");
        }
        
        if (record.getAuditRemarks() != null) {
            sql.SET("audit_remarks = #{auditRemarks,jdbcType=VARCHAR}");
        }
        
        if (record.getCreateTime() != null) {
            sql.SET("create_time = #{createTime,jdbcType=TIMESTAMP}");
        }
        
        if (record.getAuditTime() != null) {
            sql.SET("audit_time = #{auditTime,jdbcType=TIMESTAMP}");
        }
        
        if (record.getSendExpressTime() != null) {
            sql.SET("send_express_time = #{sendExpressTime,jdbcType=TIMESTAMP}");
        }
        
        if (record.getFinishTime() != null) {
            sql.SET("finish_time = #{finishTime,jdbcType=TIMESTAMP}");
        }
        
        if (record.getUpdateTime() != null) {
            sql.SET("update_time = #{updateTime,jdbcType=TIMESTAMP}");
        }
        
        if (record.getExt1() != null) {
            sql.SET("ext_1 = #{ext1,jdbcType=VARCHAR}");
        }
        
        if (record.getExt2() != null) {
            sql.SET("ext_2 = #{ext2,jdbcType=VARCHAR}");
        }
        
        if (record.getExt3() != null) {
            sql.SET("ext_3 = #{ext3,jdbcType=VARCHAR}");
        }
        
        sql.WHERE("id = #{id,jdbcType=BIGINT}");
        
        return sql.toString();
    }

    protected void applyWhere(SQL sql, BsOrderAfterSalesApplyExample example, boolean includeExamplePhrase) {
        if (example == null) {
            return;
        }
        
        String parmPhrase1;
        String parmPhrase1_th;
        String parmPhrase2;
        String parmPhrase2_th;
        String parmPhrase3;
        String parmPhrase3_th;
        if (includeExamplePhrase) {
            parmPhrase1 = "%s #{example.oredCriteria[%d].allCriteria[%d].value}";
            parmPhrase1_th = "%s #{example.oredCriteria[%d].allCriteria[%d].value,typeHandler=%s}";
            parmPhrase2 = "%s #{example.oredCriteria[%d].allCriteria[%d].value} and #{example.oredCriteria[%d].criteria[%d].secondValue}";
            parmPhrase2_th = "%s #{example.oredCriteria[%d].allCriteria[%d].value,typeHandler=%s} and #{example.oredCriteria[%d].criteria[%d].secondValue,typeHandler=%s}";
            parmPhrase3 = "#{example.oredCriteria[%d].allCriteria[%d].value[%d]}";
            parmPhrase3_th = "#{example.oredCriteria[%d].allCriteria[%d].value[%d],typeHandler=%s}";
        } else {
            parmPhrase1 = "%s #{oredCriteria[%d].allCriteria[%d].value}";
            parmPhrase1_th = "%s #{oredCriteria[%d].allCriteria[%d].value,typeHandler=%s}";
            parmPhrase2 = "%s #{oredCriteria[%d].allCriteria[%d].value} and #{oredCriteria[%d].criteria[%d].secondValue}";
            parmPhrase2_th = "%s #{oredCriteria[%d].allCriteria[%d].value,typeHandler=%s} and #{oredCriteria[%d].criteria[%d].secondValue,typeHandler=%s}";
            parmPhrase3 = "#{oredCriteria[%d].allCriteria[%d].value[%d]}";
            parmPhrase3_th = "#{oredCriteria[%d].allCriteria[%d].value[%d],typeHandler=%s}";
        }
        
        StringBuilder sb = new StringBuilder();
        List<Criteria> oredCriteria = example.getOredCriteria();
        boolean firstCriteria = true;
        for (int i = 0; i < oredCriteria.size(); i++) {
            Criteria criteria = oredCriteria.get(i);
            if (criteria.isValid()) {
                if (firstCriteria) {
                    firstCriteria = false;
                } else {
                    sb.append(" or ");
                }
                
                sb.append('(');
                List<Criterion> criterions = criteria.getAllCriteria();
                boolean firstCriterion = true;
                for (int j = 0; j < criterions.size(); j++) {
                    Criterion criterion = criterions.get(j);
                    if (firstCriterion) {
                        firstCriterion = false;
                    } else {
                        sb.append(" and ");
                    }
                    
                    if (criterion.isNoValue()) {
                        sb.append(criterion.getCondition());
                    } else if (criterion.isSingleValue()) {
                        if (criterion.getTypeHandler() == null) {
                            sb.append(String.format(parmPhrase1, criterion.getCondition(), i, j));
                        } else {
                            sb.append(String.format(parmPhrase1_th, criterion.getCondition(), i, j,criterion.getTypeHandler()));
                        }
                    } else if (criterion.isBetweenValue()) {
                        if (criterion.getTypeHandler() == null) {
                            sb.append(String.format(parmPhrase2, criterion.getCondition(), i, j, i, j));
                        } else {
                            sb.append(String.format(parmPhrase2_th, criterion.getCondition(), i, j, criterion.getTypeHandler(), i, j, criterion.getTypeHandler()));
                        }
                    } else if (criterion.isListValue()) {
                        sb.append(criterion.getCondition());
                        sb.append(" (");
                        List<?> listItems = (List<?>) criterion.getValue();
                        boolean comma = false;
                        for (int k = 0; k < listItems.size(); k++) {
                            if (comma) {
                                sb.append(", ");
                            } else {
                                comma = true;
                            }
                            if (criterion.getTypeHandler() == null) {
                                sb.append(String.format(parmPhrase3, i, j, k));
                            } else {
                                sb.append(String.format(parmPhrase3_th, i, j, k, criterion.getTypeHandler()));
                            }
                        }
                        sb.append(')');
                    }
                }
                sb.append(')');
            }
        }
        
        if (sb.length() > 0) {
            sql.WHERE(sb.toString());
        }
    }
}